#HALO INI ADALAH CLONE DARI PYROFORK.
import haku
from haku import raw
from haku import types
from typing import Union


class ReopenGeneralTopic:
    async def reopen_general_topic(
        self: "haku.Client",
        chat_id: Union[int, str]
    ) -> bool:
        """Reopen a general forum topic.

        .. include:: /_includes/usable-by/users-bots.rst

        Parameters:
            chat_id (``int`` | ``str``):
                Unique identifier (int) or username (str) of the target chat.
                You can also use chat public link in form of *t.me/<username>* (str).

        Returns:
            `bool`: On success, a True is returned.

        Example:
            .. code-block:: python

                await app.reopen_general_topic(chat_id, topic_id)
        """
        await self.invoke(
            raw.functions.channels.EditForumTopic(
                channel=await self.resolve_peer(chat_id),
                topic_id=1,
                closed=False
            )
        )
        return True
